/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>

#include "sx12.h"

int main(int argc, char *argv[])
{
        int vhan, fhan, length;
	char buffer[32768];
	int count = 0;
	

	if((vhan = open("/dev/sx12a",O_RDONLY)) <= 0)
	{
		printf("Error opening driver.\n");
		return EXIT_FAILURE;
	}
	
	if((fhan = open("test.mpg",O_WRONLY | O_CREAT, S_IRUSR | S_IWUSR)) <= 0)
	{
		printf("Error opening MPEG output file.\n");
		close(vhan);
                return EXIT_FAILURE;
	}
	
	ioctl(vhan, X12_IOC_SET_BITRATE, 2000000);

	printf("Press CTRL-C or pull any DIO to ground to terminate.\n");

	while((length = read(vhan, buffer, sizeof(buffer))) > 0 &&
	       ioctl(vhan, X12_IOC_READ_GPIO) == 0)
	{
		printf("Frames:%d\n", ioctl(vhan, X12_IOC_GET_FRAMECOUNT));
        	write(fhan, buffer, length);
	}

	close(vhan);
	close(fhan);

  	return EXIT_SUCCESS;
}
